]> git.pld-linux.org Git - packages/rpm.git/blob - rpm.macros
- line counts stright
[packages/rpm.git] / rpm.macros
1 # $Revision$, $Date$
2 # PLD Linux rpm macros
3
4 %epoch          0
5 %x8664          x86_64 amd64 ia32e
6
7 # kernel compiler
8 %kgcc           %{__cc}
9 %kgcc_package   gcc
10
11 # Build system path macros.
12 #
13 %__autoconf             autoconf %{?debug:-Wall}
14 %__automake             automake -a -c -f --foreign
15 %__autopoint            autopoint --force
16
17 %__gettextize { \
18         if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
19                 gettextize --copy --force --no-changelog; \
20         else \
21                 gettextize --copy --force --no-changelog --intl; \
22         fi; \
23         if [ ! -f po/Makevars ]; then \
24                 cp -f po/Makevars{.template,}; \
25         fi; \
26 }
27
28 %__glib_gettextize      glib-gettextize --copy --force
29 %__gnome_doc_common     gnome-doc-common --copy
30 %__gnome_doc_prepare    gnome-doc-prepare --copy --force
31 %__gtkdocize            gtkdocize --copy
32 %__intltoolize          intltoolize --copy --force
33 %__libtoolize           libtoolize --copy --force
34
35 #       The number of cvs changelog entries kept when building package.
36 %_buildchangelogtruncate 20
37
38 %dependencytracking     %{nil}
39
40 #       Relations between package names that cause dependency loops
41 #       with legacy packages that cannot be fixed. Relations are
42 #       specified as
43 #               p>q
44 #       where package p has a Requires: on something that package q Provides:
45 #
46 # XXX   Note: that there cannot be any whitespace within the string "p>q",
47 #       and that both p and q are package names (i.e. no version/release).
48 %_dependency_whiteout   %{nil}
49
50 %_smp_mflags %([ -z "$RPM_BUILD_NCPUS" ] \\\
51         && RPM_BUILD_NCPUS="`/usr/bin/getconf _NPROCESSORS_ONLN`"; \\\
52         [ "$RPM_BUILD_NCPUS" -gt 1 ] && echo "-j$RPM_BUILD_NCPUS")
53
54 #-----------------------------------------------------------------
55 #
56 # (re)definition of %{rpm*flags} with %filterout_* support
57 # BuildRequires:        awk
58 # BuildRequires:        rpmbuild(macros) >= 1.315
59 #
60 # Flags specified in %filterout_* are removed from %rpm*flags, exactly:
61 # %rpmcflags    = %optflags - %filterout - %filterout_c   - %filterout_ld
62 # %rpmcxxflags  = %optflags - %filterout - %filterout_cxx - %filterout_ld
63 # %rpmldflags   = %optldflags - %filterout_ld
64 #
65 # Regular expressions are supported, but to avoid some character be treated
66 # as regular expression it must be escaped twice.
67
68 %filter_out                                             \
69         for (i = 1; i in I; i++) {      A=0;    \
70                 for (f in F) {                          \
71                         if (I[i] ~ "^" F[f] "$") A=1;   \
72                 };                                                      \
73                 if (!A) printf(I[i] FS);        \
74         }
75
76 %rpmcflags %(awk 'BEGIN {
77         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
78         split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
79         %{filter_out}
80 }')
81
82 %rpmcxxflags %(awk 'BEGIN {
83         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
84         split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
85         %{filter_out}
86 }')
87
88 %rpmldflags %(awk 'BEGIN {
89         split("%{?optldflags}",I);
90         split("%{?filterout_ld}",F)
91         %{filter_out}
92 }')
93
94 # rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
95 # but, don't use it, better use gcc as linker
96 %ld_rpmldflags %(awk 'BEGIN {
97         split("%{rpmldflags}",F);
98         for (f in F) {
99                 s = F[f];
100                 if (s ~ /^-Wl,/) {
101                         s = substr(s,5);
102                         gsub(/,/," ",s);
103                 };
104                 printf(s FS);
105         };
106 }')
107
108 #-----------------------------------------------------------------
109 %configure2_13 { \
110  if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
111  LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
112  CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
113  CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
114  FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
115  FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
116  CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
117  %{?__cc:CC="%{__cc}" ; export CC ; } \
118  %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
119  %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
120         --host=%{_target_platform} \
121         --prefix=%{_prefix} \
122         --exec-prefix=%{_exec_prefix} \
123         --bindir=%{_bindir} \
124         --sbindir=%{_sbindir} \
125         --sysconfdir=%{_sysconfdir} \
126         --datadir=%{_datadir} \
127         --includedir=%{_includedir} \
128         --libdir=%{_libdir} \
129         --libexecdir=%{_libexecdir} \
130         --localstatedir=%{_localstatedir} \
131         --sharedstatedir=%{_sharedstatedir} \
132         --mandir=%{_mandir} \
133         --infodir=%{_infodir} \
134         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
135         %{dependencytracking} \
136 }
137
138 # override __cmake to add -j4 in your ~/.rpmmacros for parallel make
139 %__cmake        /usr/bin/cmake
140 %cmake { \
141 CC="%{__cc}" \
142 CXX="%{__cxx}" \
143 CFLAGS="%{rpmcflags}" \
144 CXXFLAGS="%{rpmcxxflags}" \
145 %{__cmake} \
146 }
147
148 # override __scons to add -j4 in your ~/.rpmmacros for parallel make
149 %__scons        /usr/bin/scons
150 %scons { \
151 %{__scons} \
152         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
153         CFLAGS="${CFLAGS:-%rpmcflags}" \
154         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
155         FFLAGS="${FFLAGS:-%rpmcflags}" \
156         CPPFLAGS="${CPPFLAGS:-}" \
157         %{?__cc:CC="%{__cc}"} \
158         %{?__cxx:CXX="%{__cxx}"} \
159         libsuffix=%{_lib} \
160         prefix=%{_prefix} \
161 }
162
163 # waf. see waf.spec
164 # override __waf to add -j4 in your ~/.rpmmacros for parallel make
165 %__waf  /usr/bin/waf
166 %waf { \
167 CC="%{__cc}" \
168 CXX="%{__cxx}" \
169 CPP="%{__cpp}" \
170 CFLAGS="%{rpmcflags}" \
171 CXXFLAGS="%{rpmcxxflags}" \
172 %{__waf} \
173 }
174
175 #----------------------------------------------------------------
176 %global configure_cache 0
177 %configure_cache_file   %{buildroot}.configure.cache
178
179 %configure {./configure \
180         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
181         CFLAGS="${CFLAGS:-%rpmcflags}" \
182         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
183         FFLAGS="${FFLAGS:-%rpmcflags}" \
184         FCFLAGS="${FCFLAGS:-%rpmcflags}" \
185         CPPFLAGS="${CPPFLAGS:-}" \
186         %{?__cc:CC="%{__cc}"} \
187         %{?__cxx:CXX="%{__cxx}"} \
188         --host=%{_target_platform} \
189         --build=%{_target_platform} \
190         --prefix=%{_prefix} \
191         --exec-prefix=%{_exec_prefix} \
192         --bindir=%{_bindir} \
193         --sbindir=%{_sbindir} \
194         --sysconfdir=%{_sysconfdir} \
195         --datadir=%{_datadir} \
196         --includedir=%{_includedir} \
197         --libdir=%{_libdir} \
198         --libexecdir=%{_libexecdir} \
199         --localstatedir=%{_localstatedir} \
200         --sharedstatedir=%{_sharedstatedir} \
201         --mandir=%{_mandir} \
202         --infodir=%{_infodir} \
203         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
204         %{dependencytracking} \
205         %{?configure_cache:--cache-file=%{configure_cache_file:-%{buildroot}.configure.cache}} \
206 }
207
208 # Location of autoconf macros
209 %_aclocaldir    %(aclocal --print-ac-dir)
210
211 # Location of omf files
212 %_omf_dest_dir  %(scrollkeeper-config --omfdir)
213
214 # Location of pkgconfig files
215 %_pkgconfigdir  /usr/%{_lib}/pkgconfig
216
217 # Location of desktop files
218 %_desktopdir    /usr/share/applications
219 %_applnkdir     ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
220
221 # Location of pixmaps for applnk/desktop files
222 %_pixmapsdir    /usr/share/pixmaps
223
224 # Location of themable icons for applnk/desktop files
225 %_iconsdir      /usr/share/icons
226
227 # Location of fonts directories
228 %_fontsdir      /usr/share/fonts
229
230 # Location of Gtk and associated libraries documentation
231 %_gtkdocdir     %{_defaultdocdir}/gtk-doc/html
232
233 # Location of KDE documentation
234 %_kdedocdir     %{_defaultdocdir}/kde/HTML
235
236 # unsermake script
237 %__unsermake /usr/share/unsermake/unsermake
238
239 # Current date
240 %date           %(LC_ALL="C" date +"%a %b %d %Y")
241
242 # tmp directory
243 %tmpdir         %(echo "${TMPDIR:-/tmp}")
244
245 # Example files, programs, scripts...
246 %_examplesdir   /usr/src/examples
247
248 # Alternative kernel type/version
249 %_alt_kernel    %{nil}%{?alt_kernel:-%{?alt_kernel}}
250
251 # The directory holding Linux kernel sources
252 %_kernelsrcdir  /usr/src/linux%{_alt_kernel}
253
254 # If non-empty "debug" macro defined, add "dbg" suffix to release number
255 %_rpmfilename           %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
256
257 # Requires name = version-release
258 %requires_releq()               %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}-%%{release}\\n' | sed -e 's/ (none):/ /' | grep -v "is not")
259
260 %releq_kernel()                 %((LC_ALL="C" rpm -qf --qf '%%{name} = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
261 %releq_kernel_up()              %((LC_ALL="C" rpm -qf --qf '%%{name}-up = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
262 %releq_kernel_smp()             %((LC_ALL="C" rpm -qf --qf '%%{name}-smp = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
263 %requires_releq_kernel(s:)              Requires%{-s:(%{-s*})}: %releq_kernel
264 %requires_releq_kernel_up(s:)   Requires%{-s:(%{-s*})}: %releq_kernel_up
265 %requires_releq_kernel_smp(s:)  Requires%{-s:(%{-s*})}: %releq_kernel_smp
266
267 %requires_eq()          %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}\\n' | sed -e 's/ (none):/ /' -e 's/ 0:/ /' | grep -v "is not")
268 %requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %%{epoch}:%%{version}\\n' %2 | sed -e 's/ (none):/ /' | grep -v "is not")
269
270 %apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)
271
272 # kernel version-release handling
273 %__kernel_ver   %( VER_H=%{_kernelsrcdir}/include/linux/utsrelease.h; [ -f $VER_H ] || VER_H=%{_kernelsrcdir}/include/linux/version.h; [ -f $VER_H ] && (grep UTS_RELEASE $VER_H 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))
274 %__kernel_rel   %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{RELEASE}" | grep -v "is not")
275 %__kernel_rpmvr %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{VERSION}-%{RELEASE}" | grep -v "is not")
276 %_kernel_ver    %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}
277 %_kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')
278
279 # sgml macros
280 %xmlcat_add()           /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
281 %xmlcat_del()           /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
282 %xmlcat_add_rewrite     /usr/bin/xmlcatalog --noout --add rewriteSystem
283 %xmlcat_create()        /usr/bin/xmlcatalog --noout --create %1 ;
284 %sgmlcat_add()          /usr/bin/install-catalog --add %1 %2 > /dev/null ;
285 %sgmlcat_del()          /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
286 %docbook_sgmlcat_fix() { for l in \
287 '' \
288 '  -- default decl --' \
289 'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
290 '  -- hacks for opensp --' \
291 'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
292 'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd"                  "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
293 '' \
294 ; do echo $l; done >> %1 \
295 }
296
297 # vim - "
298
299 # minimum file size needed for compressed documents.
300 # just smaller files than this get larger when compressed.
301 # some stats:
302 # - 0 byte file compressed was 25 bytes .gz
303 # - 39 byte file was compressed as 57
304 # - with test/test.spec@man 158 byte file was compressed also 158
305 %_min_compress_bytes    159
306
307 #-----------------------------------------------------------------
308 # find and gzip all files in %{_mandir} and %{infodir}
309 #
310 # Requires: xargs, find
311 #
312 #%no_install_post_compress_docs 1
313 %__spec_install_post_compress_docs { \
314 %{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
315         for i in /usr/share/man /usr/X11R6/man; do \
316                 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
317                         echo "Compress man pages: $i"; \
318                         find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
319                         find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
320                         find $RPM_BUILD_ROOT$i -type l | while read a; do \
321                                 m=$(readlink $a); \
322                                 rm -f $a; \
323                                 echo .so ${m##*/} > $a; \
324                                 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
325                         done; \
326                         find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
327                 fi; \
328         done; \
329         if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
330                 echo "Compress info pages: %{_infodir}"; \
331                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
332                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
333                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
334         fi; \
335 }; __spec_install_post_compress_docs } }
336
337 #-----------------------------------------------------------------
338 # Strip executable binaries and shared object files
339 #
340 # Requires: find, awk, strip, cut, xargs
341 #
342 # Special macros which affect this process:
343 #%no_install_post_strip 1               # disable stripping at all
344 #%_noautostrip                  regexp  # exclude files matching (anchored!) regex from stripping
345 #%_autostripall                 regexp  # strip files matching (anchored!) regex using plain strip
346 #%_autostripunneeded    regexp  # strip files matching (anchored!) regex using strip --strip-unneeded
347 #%_autostripdebug               regexp  # strip files matching (anchored!) regex using strip --strip-debug
348 #
349 %__spec_install_post_strip {%{!?debug: \
350 %{!?no_install_post_strip:__spec_install_post_strip() { \
351 if [ -d "$RPM_BUILD_ROOT" ]; then \
352         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
353                 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
354                 modulecount=$(echo -n "$modulelist" | wc -l); \
355                 if [ "$modulecount" -gt 0 ]; then \
356                         printf "Stripping %d kernel modules..." $modulecount; \
357                         echo "$modulelist" | xargs -l512 chmod u+w; \
358                         echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
359                         echo "DONE"; \
360                 fi; \
361         fi; \
362         filelist=`find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}`; \
363         if [ -n "$filelist" ]; then \
364                 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
365                 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
366                 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
367                 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
368                 if [ -n "$elfexelist" ]; then \
369                         printf "Stripping %d ELF executables..." $(echo -n "$elfexelist" | wc -l); \
370                         chmod u+w $elfexelist; \
371                         %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
372                         echo "DONE"; \
373                 fi; \
374                 if [ -n "$elfsharedlist" ]; then \
375                         printf "Stripping %d ELF shared libraries..." $(echo -n "$elfsharedlist" | wc -l); \
376                         chmod u+w $elfsharedlist; \
377                         %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
378                         echo "DONE"; \
379                 fi; \
380                 if [ -n "$archiveslist" ]; then \
381                         printf "Stripping %d ar archives..." $(echo -n "$archiveslist" | wc -l); \
382                         chmod u+w $archiveslist; \
383                         %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
384                         echo "DONE"; \
385                 fi; \
386         fi; \
387     filelist_all=%{?_autostripall:`find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}"`}; \
388     filelist_unneeded=%{?_autostripunneeded:`find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}"`}; \
389     filelist_debug=%{?_autostripdebug:`find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}"`}; \
390         if [ -n "$filelist_all" ]; then \
391                 printf "Stripping everything from %d additional files..." $(echo -n "$filelist_all" | wc -l); \
392                 chmod u+w $filelist_all; \
393                 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
394                 echo "DONE"; \
395         fi; \
396         if [ -n "$filelist_unneeded" ]; then \
397                 printf "Stripping unneeded from %d additional files..." $(echo -n "$filelist_unneeded" | wc -l); \
398                 chmod u+w $filelist_unneeded; \
399                 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
400                 echo "DONE"; \
401         fi; \
402         if [ -n "$filelist_debug" ]; then \
403                 printf "Stripping debuginfo from %d additional files..." $(echo -n "$filelist_debug" | wc -l); \
404                 chmod u+w $filelist_debug; \
405                 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
406                 echo "DONE"; \
407         fi; \
408 fi; }; __spec_install_post_strip } } }
409
410 #-----------------------------------------------------------------
411 # remove all RPATH from executable binaries and shared object files
412 #
413 # Requires: find, awk, cut, xargs, chrpath, uname
414 #
415 # Special macros which affect this process
416 #%no_install_post_chrpath       1       # disable chrpath at all
417 #%_noautochrpath        regex           # exclude files matching (anchored!) regex from chrpath
418 #
419 %__spec_install_post_chrpath {%{!?debug: \
420 %{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
421 if [ -d "$RPM_BUILD_ROOT" ]; then \
422         files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*"  %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
423         if [ -n "$files" ]; then \
424                 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
425         fi
426         #"
427         if [ -n "$objs" ]; then \
428                 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo -n "$objs" | wc -l); \
429                 echo "$objs" | \
430                 while read file; do \
431                         rpath= ; \
432                         chmod u+w "$file"; \
433                         for dir in `chrpath -l "$file" | \
434                                         awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
435                                         case $dir in \
436                                         /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
437                                                 echo "remove-rpath: $dir in $file"; \
438                                                 ;; \
439                                         * ) \
440                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
441                                                 else rpath="$rpath:$dir" ; fi ; \
442                                                 ;; \
443                                         esac ; \
444                         done ; \
445                         if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
446                         else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
447                 done; \
448         fi; \
449 fi; }; __spec_install_post_chrpath } } }
450
451 #-----------------------------------------------------------------
452 # Find and gzip all kernel modules
453 #
454 # Requires: find
455 #
456 #%no_install_post_compress_modules      1
457 %__spec_install_post_compress_modules { \
458 %{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
459         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
460                 echo "Compress kernel modules"; \
461                 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
462                 echo "$q" | xargs -r %{__gzip} -9nf; \
463                 printf "%d modules compressed\n" $(echo -n "$q" | wc -l); \
464                 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
465                 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
466         fi; \
467 }; __spec_install_post_compress_modules } }
468
469 # Remove common Perl files we don't package
470 %__spec_install_post_perl_clean {\
471 %{!?no_install_post_perl_clean: \
472 %{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
473 } }
474
475 #-----------------------------------------------------------------
476 # Update GConf2 schemas
477 #
478 # Requires: GConf2
479 #
480 %gconf_schema_install() \
481         umask 022; \
482         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null \
483         %{nil}
484
485 %gconf_schema_uninstall() \
486 if [ $1 = 0 ]; then \
487         umask 022; \
488         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
489 fi \
490 %{nil}
491
492 #-----------------------------------------------------------------
493 # Update desktop MIME database
494 # requires: desktop-file-utils
495 #
496 %update_desktop_database_post() {{ \
497         umask 022; \
498         /usr/bin/update-desktop-database -q; \
499 }} \
500 %{nil}
501
502 %update_desktop_database_postun() {{ \
503 if [ $1 = 0 ]; then \
504         umask 022; \
505         /usr/bin/update-desktop-database -q; \
506 fi \
507 }} \
508 %{nil}
509
510 #-----------------------------------------------------------------
511 # Update shared MIME info database
512 # requires: shared-mime-info
513 #
514 %update_mime_database() {{ \
515         umask 022; \
516         /usr/bin/update-mime-database %{_datadir}/mime; \
517 }} \
518 %{nil}
519
520 #-----------------------------------------------------------------
521 # Update icon cache
522 # requires: gtk+
523 #
524 %update_icon_cache() {{ \
525         umask 022; \
526         /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
527 }} \
528 %{nil}
529
530 #-----------------------------------------------------------------
531 # Update scrollkeeper database
532 # requires: scrollkeeper
533 #
534 %scrollkeeper_update_post() \
535         /usr/bin/scrollkeeper-update -q; \
536         %{nil}
537
538 %scrollkeeper_update_postun() \
539 if [ $1 = 0 ]; then \
540         /usr/bin/scrollkeeper-update -q; \
541 fi \
542 %{nil}
543
544 #-----------------------------------------------------------------
545 # post %install sequence:
546 # - autodeps exceptions
547 # - compress all man and info pages,
548 # - strip all ELF executables and ELF shared objects if not %debug.
549 # - compress kernel modules if any
550
551 ###################################################################
552 # Requires/Provides automation
553 # exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
554 #
555 %__noautoreqfiles       %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
556 %__noautoprovfiles      %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
557 %__noautoreq            %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
558 %__noautoreqdep         %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
559 %__noautoprov           %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
560 #%_noautocompressdoc    %{nil}
561 #
562 %_missing_doc_files_terminate_build     1%{nil}
563 %_unpackaged_files_terminate_build      %{nil}
564 # (X)emacs support
565 %___emacs_lispdir_helper  -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
566 %_emacs_lispdir %(emacs %___emacs_lispdir_helper)
567 %_xemacs_lispdir %(xemacs %___emacs_lispdir_helper)
568
569 %__php_provides %{nil}
570 %__php_requires %{nil}
571 %__perl_provides %{nil}
572 %__perl_requires %{nil}
573 %__mono_provides %{nil}
574 %__mono_requires %{nil}
575
576 # Perl specific macro definitions.
577 %perl_privlib           %(eval "`%{__perl} -V:installprivlib`"; echo $installprivlib)
578 %perl_archlib           %(eval "`%{__perl} -V:installarchlib`"; echo $installarchlib)
579 %perl_vendorlib         %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)
580 %perl_vendorarch        %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)
581 %perl_sitelib           %(eval "`%{__perl} -V:installsitelib`"; echo $installsitelib)
582 %perl_sitearch          %(eval "`%{__perl} -V:installsitearch`"; echo $installsitearch)
583
584 # Ruby
585 %ruby_archdir           %(ruby -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)
586 %ruby_ridir                     %(ruby -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)
587 %ruby_rubylibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)
588 %ruby_vendorarchdir     %(ruby -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)
589 %ruby_vendorlibdir      %(ruby -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)
590 %ruby_sitearchdir       %(ruby -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)
591 %ruby_sitelibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)
592 %ruby_version           %(ruby -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)
593 %ruby_ver_requires_eq   Requires:       ruby(ver) = %ruby_version
594 %ruby_mod_ver_requires_eq       Requires:       ruby-modules(ver) = %ruby_version
595
596 %php_pear_dir           /usr/share/pear
597 %php_extensiondir       %(php-config --extension-dir 2>/dev/null || echo ERROR)
598 %php_sysconfdir         %(php-config --sysconfdir 2>/dev/null || echo ERROR)
599 %php_includedir         %(php-config --include-dir 2>/dev/null || echo ERROR)
600
601 # extract php/zend api versions
602 %php_major_version              %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)
603 %php_api_version                %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)
604 %php_pdo_api_version    %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)
605 %php_debug                              %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)
606 %zend_module_api                %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)
607 %zend_extension_api             %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)
608 %zend_zts                               %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})
609
610 # helper macro
611 %__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
612
613 # macros for public use
614 # for php extensions (php-pecl)
615 %requires_php_extension %{__php_api_requires modules_api php_api_version} \
616 %{__php_api_requires zend_module_api} \
617 %{__php_api_requires -v %php_major_version debug php_debug} \
618 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
619
620 # for zend extensions
621 %requires_zend_extension %{__php_api_requires zend_module_api} \
622 %{__php_api_requires zend_extension_api} \
623 %{__php_api_requires -v %php_major_version debug php_debug} \
624 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
625
626 # for php pdo modules (php-pecl-PDO_*)
627 %requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
628
629 # for using PHP post scripts. for PHP >= 5.0
630 %php_webserver_restart \
631 [ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
632 [ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
633 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
634         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
635         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
636                 %service -q php-fcgi restart \
637         fi \
638 fi \
639 %{nil}
640
641 # for using php post scripts. for PHP >= 4.0 && PHP < 5.0
642 %php4_webserver_restart \
643 [ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
644 [ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
645 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
646         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
647         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
648                 %service -q php-fcgi restart \
649         fi \
650 fi \
651 %{nil}
652
653
654 # X.org helper macros
655 %__xorg_abi_requires() Requires: xorg-xserver-server(%{expand:%1}-abi) = %{expand:%{%{!?2:%{1}}%{?2}}}
656 #
657 %xorg_xserver_ansic_abi         %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
658 %xorg_xserver_extension_abi     %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
659 %xorg_xserver_font_abi          %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)
660 %xorg_xserver_videodrv_abi      %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
661 %xorg_xserver_xinput_abi        %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
662
663 %requires_xorg_xserver_extension %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
664 %{__xorg_abi_requires extension xorg_xserver_extension_abi}
665 %requires_xorg_xserver_xinput %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
666 %{__xorg_abi_requires xinput xorg_xserver_xinput_abi}
667 %requires_xorg_xserver_font %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
668 %{__xorg_abi_requires font xorg_xserver_font_abi}
669 %requires_xorg_xserver_videodrv %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
670 %{__xorg_abi_requires videodrv xorg_xserver_videodrv_abi}
671
672 # Python specific macro definitions.
673 # python main version
674 %py_ver                 %(python -c "import sys; print sys.version[:3]")
675
676 # directories
677 %py_prefix              %(python -c "import sys; print sys.prefix")
678 %py_libdir              %{py_prefix}/%{_lib}/python%{py_ver}
679 %py_scriptdir   %{py_prefix}/share/python%{py_ver}
680 %py_incdir              /usr/include/python%{py_ver}
681 %py_sitedir             %{py_libdir}/site-packages
682 %py_sitescriptdir %{py_scriptdir}/site-packages
683 %py_dyndir              %{py_libdir}/lib-dynload
684
685 # pure python modules compilation
686 %py_comp                python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
687
688 %py_ocomp               python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
689
690 # Software written in Python language require Python with main version
691 %pyrequires_eq() Requires:      %1
692
693 # Hardlink binary identical .pyc and .pyo files
694 # (idea by glen <at> pld-linux <dot> org)
695 %__spec_install_post_py_hardlink {\
696 %{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
697 [ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
698         b="${a%.pyc}.pyo"; \
699         if cmp -s "$a" "$b"; then \
700                 ln -f "$a" "$b"; \
701         fi; \
702 done \
703 }; __spec_install_post_py_hardlink } }
704
705 # remove python sources, so that check-files won't complain
706 # (idea by glen <at> pld-linux <dot> org)
707 %py_postclean() \
708 for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
709  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
710 done \
711 %{nil}
712
713 # depmod macro
714 %depmod() { \
715 umask 022; \
716 if [ -e /boot/System.map-%1 ]; then \
717         /sbin/depmod -a -F /boot/System.map-%1 %1; \
718 else \
719         if [ -e /boot/System.map ]; then \
720                 /sbin/depmod -a -F /boot/System.map %1; \
721         else \
722                 /sbin/depmod -a %1; \
723         fi \
724 fi; \
725 }
726
727 # XMMS specific macros
728 %xmms_prefix                    %(xmms-config --prefix 2>/dev/null)
729 %xmms_exec_prefix               %(xmms-config --exec-prefix 2>/dev/null)
730 %xmms_version                   %(xmms-config --version 2>/dev/null)
731 %xmms_datadir                   %(xmms-config --data-dir 2>/dev/null)
732 %xmms_plugindir                 %(xmms-config --plugin-dir 2>/dev/null)
733 %xmms_visualization_plugindir   %(xmms-config --visualization-plugin-dir 2>/dev/null)
734 %xmms_input_plugindir           %(xmms-config --input-plugin-dir 2>/dev/null)
735 %xmms_output_plugindir          %(xmms-config --output-plugin-dir 2>/dev/null)
736 %xmms_effect_plugindir          %(xmms-config --effect-plugin-dir 2>/dev/null)
737 %xmms_general_plugindir         %(xmms-config --general-plugin-dir 2>/dev/null)
738
739 %_target_base_arch      %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')
740
741 # user/group checking macros
742 #
743 # Usage:
744 #       %userremove myuser
745 #
746 %userremove     /usr/lib/rpm/user_group.sh user del
747 %groupremove    /usr/lib/rpm/user_group.sh group del
748 #
749 # Usage:
750 #       if %usertestrm myuser; then
751 #               /usr/sbin/userdel -r myuser
752 # Note:
753 #       use these macros only if you need to call userdel/groupdel with
754 #       a non-standard option or take an extra action; otherwise use the
755 #       %userremove/%groupremove macros
756 #
757 %usertestrm     /usr/lib/rpm/user_group.sh user testrm
758 %grouptestrm    /usr/lib/rpm/user_group.sh group testrm
759 # user group membership management macros
760 #
761 # Usage:
762 #       %addusertogroup myuser agroup
763 #
764 %addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
765
766 # banner support (useful in {pre,post}{,un} and triggers)
767 #
768 # Usage:
769 #       %banner name [-a] [-e] [-n] [-tn] <<EOF
770 # the banner text, the banner text
771 # the banner text, and following line
772 #EOF
773 # You can use any form of here-document, <<'EOF' <<-EOT will do.
774 # NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
775 #
776 # -a   - append to the banner
777 # -e   - send to stderr instead of stdout
778 # -n   - no show banner (overrides -t)
779 # -t   - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
780 #
781 # Tests:
782 # (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
783 # rpm -E 'date | %banner -e banner' > m; sh -x m
784 #
785 %banner(aent:) ( \
786 RPM_SCRIPTVERBOSITY=5 \
787 [ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
788 if [ -x /usr/bin/banner.sh ]; then \
789         CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
790 else \
791         CMD="cat%{-e: >&2}" \
792 fi \
793 eval $CMD %{?2:%2}%{?3: %3}) \
794 %{nil}
795
796 # useradd/groupadd macros
797 # Author: Elan Ruusamäe <glen@pld-linux.org>
798 #
799 # Usage:
800 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
801 #   [-g initial_group] [-G group[,...]] login
802 #
803 #  -u uid. REQUIRED
804 #  -g gid/group. REQUIRED
805 #  -s defaults to /bin/false
806 #  -d defaults to /usr/share/empty
807 #  -c No default
808 #  -r is accepted but ignored (it's always set)
809 #  -k skeleton dir. defaults to /usr/share/empty
810 # rpm specific flags
811 #  -P package name. defaults to %{name}
812 #
813 %useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
814 %{!-u:%{error:useradd: Required argument -u missing}} \
815 %{!-g:%{error:useradd: Required argument -g missing}} \
816 %{!?1:%{error:useradd: Required parameter login missing}} \
817 if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
818         if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
819                 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
820                 exit 1 \
821         fi \
822 else \
823         echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
824         /usr/sbin/useradd \\\
825                 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
826                 -u %{-u*} \\\
827                 -r \\\
828                 -d %{-d*}%{!-d:/usr/share/empty} \\\
829                 -s %{-s*}%{!-s:/bin/false} \\\
830                 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
831                 -g %{-g*} \\\
832                 %{-M} \\\
833                 %{-G:-G %{-G*}} \\\
834                 %{expand:%{%{#}}} 1>&2 || exit $? \
835         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
836 fi;
837
838 # Usage:
839 #   %groupadd [-P package] [-g gid] group
840 #
841 # -g gid. REQUIRED
842 #
843 # Sample:
844 #   %groupadd -P %{name}-base -g %{gid} %{name}
845
846 %groupadd(g:P:rfo)      \
847 %{!-g:%{error:groupadd: Required argument -g missing}} \
848 %{!?1:%{error:groupadd: Required parameter group missing}} \
849 if [ -n "`/usr/bin/getgid %{1}`" ]; then \
850         if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
851                 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
852                 exit 1 \
853         fi \
854 else \
855         echo "Adding group %{1} GID=%{-g*}." \
856         /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
857         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
858 fi;
859
860 # webapp macros
861 # Author: Elan Ruusamäe <glen@pld-linux.org>
862 #
863 # The config is installed/removed inside trigger, this means that you can any
864 # time install apache1/apache/lighttpd package and the configuration file is
865 # updated. if you don't need the config for various reason for specific
866 # webserver, just remove the symlink from config directory using webapp
867 # program. the trigger will not recreate the symlink on upgrades. In other
868 # words the config is linked to webserver config directory on first install of
869 # PACKAGE or WEBSERVER.
870 #
871 # Add package's webserver config to webserver webapps dir.
872 # Usage:
873 #   %webapp_register WEBSERVER WEBAPP
874 #
875 %webapp_register() \
876 %{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
877 if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
878         /usr/sbin/webapp register %1 %2\
879 fi\
880 # reload webserver if the config symlink is there and skip reload if webserver is upgraded\
881 if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
882         %{expand:%service -q %%1 reload}\
883 fi\
884 %{nil}
885
886 # Remove package's config from webserver webapps dir.
887 # Usage:
888 #   %webapp_register [-f] WEBSERVER WEBAPP
889 %webapp_unregister(f) \
890 %{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
891 # remove link if either of the packages are gone \
892 if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
893         /usr/sbin/webapp unregister %1 %2\
894         %{expand:%service -q %%1 reload}\
895 fi \
896 %{nil}
897
898 # service macro.
899 # Author: Elan Ruusamäe <glen@pld-linux.org>
900 #
901 # calls usual service restart on package %post, but skips the restart if
902 # administrator has disabled automatic service restarts in either global
903 # /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
904 #
905 # Usage:
906 #   %service [-q] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
907 #
908 #  -q be silent when service isn't started (for scriplets restaring other package's services)
909 #
910 %service(q) {{%(export quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
911
912
913 # Java macros. based on jpackage macros.java
914 #
915 # Root directory where all Java VMs/SDK/JREs are installed.
916 %_jvmdir                %{_libdir}/jvm
917
918 # Root directory where all Java VMs/SDK/JREs expose their jars
919 %_jvmjardir             %{_libdir}/jvm-exports
920
921 # Root directory for all Java VM/SDK/JRE's private things.
922 %_jvmprivdir    %{_libdir}/jvm-private
923
924 # Root directory for all architecture dependent parts of Java VM/SDK/JRE's
925 %_jvmlibdir             %{_libdir}/jvm
926
927 # Root directory for all architecture independent parts of Java VM/SDK/JRE's
928 %_jvmdatadir    %{_datadir}/jvm
929
930 # Root directory for all configurations parts of Java VM/SDK/JRE's
931 %_jvmsysconfdir %{_sysconfdir}/jvm
932
933 # Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
934 %_jvmcommonlibdir       %{_libdir}/jvm-common
935
936 # Root directory for all common architecture independent parts of Java VM/SDK/JRE's
937 %_jvmcommondatadir      %{_datadir}/jvm-common
938
939 # Root directory for all common configurations parts of Java VM/SDK/JRE's
940 %_jvmcommonsysconfdir   %{_sysconfdir}/jvm-common
941
942 # Directory where arch-specific (JNI) version-independent jars are installed.
943 %_jnidir                %{_libdir}/java
944
945 %java_home              %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})
946
947 %ant                    JAVA_HOME=%{java_home} ant
948 %jar                    %{java_home}/bin/jar
949 %java                   %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)
950 %javac                  %{java_home}/bin/javac
951 %javadoc                %{java_home}/bin/javadoc
952
953 %add_jvm_extension      JAVA_LIBDIR=%{buildroot}/%{_javadir}    %{_bindir}/jvmjar -l
954
955 %jpackage_script() \
956 install -d $RPM_BUILD_ROOT%{_bindir}\
957 cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
958 #!/bin/sh\
959 #\
960 # %{name} script\
961 # JPackage Project <http://www.jpackage.org/>\
962 \
963 # Source functions library\
964 . %{_javadir}-utils/java-functions\
965 \
966 # Source system prefs\
967 if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
968     . %{_sysconfdir}/java/%{name}.conf\
969 fi\
970 \
971 # Source user prefs\
972 if [ -f $HOME/.%{name}rc ]; then\
973     . $HOME/.%{name}rc\
974 fi\
975 \
976 # Configuration\
977 MAIN_CLASS=%1\
978 BASE_FLAGS=%2\
979 BASE_OPTIONS=%3\
980 BASE_JARS="%(echo %4 | tr ':' ' ')"\
981 \
982 # Set parameters\
983 set_jvm\
984 set_classpath $BASE_JARS\
985 set_flags $BASE_FLAGS\
986 set_options $BASE_OPTIONS\
987 \
988 # Let's start\
989 run "$@"\
990 EOF
991
992 # jpackage 1.7
993 # Directory for maven depmaps
994 #
995 %_mavendepmapdir /etc/maven
996 %_mavendepmapfragdir /etc/maven/fragments
997
998 #
999 # add_to_depmap adds an entry to the depmap. The arguments are:
1000 #
1001 # %1 the original groupid
1002 # %2 the original artifact id
1003 # %3 the version
1004 # %4 the new groupid
1005 # %5 the new artifactid
1006 #
1007
1008 %add_to_maven_depmap() \
1009 install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1010 cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1011 <dependency>\
1012     <maven>\
1013         <groupId>%1</groupId>\
1014         <artifactId>%2</artifactId>\
1015         <version>%3</version>\
1016     </maven>\
1017     <jpp>\
1018         <groupId>%4</groupId>\
1019         <artifactId>%5</artifactId>\
1020         <version>%3</version>\
1021     </jpp>\
1022 </dependency>\
1023 \
1024 EOF\
1025 %{nil}
1026
1027 #==============================================================================
1028 #
1029 # update_maven_depmap updates the main maven depmap
1030 #
1031 %update_maven_depmap() \
1032 echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1033 if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1034 cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1035 fi\
1036 echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1037
1038
1039 # PEAR install macros
1040 # Author: Elan Ruusamäe <glen@pld-linux.org>
1041 #
1042 # Usage:
1043 #       %%pear_package_setup [-a #] [-n FMT]
1044 #
1045 # -a #   - also unpack SOURCE#. for PEAR bootstrapping
1046 # -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1047 # -z     - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1048 #
1049 # unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1050 # destination hierarchy. you should copy the tree to buildroot after
1051 # patching/reorganizing with %%pear_package_install.
1052 #
1053 # additionally BUILDROOT is stripped from files and files are converted to UNIX
1054 # line endings.
1055 #
1056 # the pear install process output is recorded to install.log, you should put it
1057 # to %%doc for later debug or just for information.
1058 #
1059 # additionally additional-packages.txt is produced if it was detected that the
1060 # package has optional dependencies. the file format is suitable of displaying
1061 # in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1062 # automatically added for this file.
1063
1064
1065 # records install.log and transforms PEAR names to PLD Linux rpm package names.
1066 %__pear_install_log \
1067 tee install.log \
1068 # make post message of optional packages \
1069 grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,' > optional-packages.txt \
1070 if [ -s optional-packages.txt ]; then \
1071         awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1072 else \
1073         rm -f optional-packages.txt \
1074 fi \
1075 %{nil}
1076
1077 # command invoking pear cli
1078 %__pear /usr/bin/pear
1079
1080 %pear_install(a:n:zD) \
1081 %__pear \\\
1082         -c pearrc \\\
1083         -d doc_dir=/docs \\\
1084         -d php_dir=%{php_pear_dir} \\\
1085         -d bin_dir=%{_bindir} \\\
1086         -d data_dir=%{php_pear_dir}/data \\\
1087         -d test_dir=%{php_pear_dir}/tests \\\
1088         install \\\
1089         --packagingroot=%{builddir} \\\
1090         --offline \\\
1091         --nodeps \\\
1092         %{-f:--force} \\\
1093         %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1094 %{nil}
1095
1096 # The main macro.
1097 # using this macro will append optional-packages.txt to the nocompressdoc list
1098 # as it's displayed to user after package install. and adding additional gzip
1099 # dep is just waste ;)
1100 %pear_package_setup(a:n:zD) \
1101 %define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1102 %define builddir %{_builddir}/%{srcdir} \
1103 %setup -q -c -T %{-D:-D} -n %{srcdir} \
1104 %{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1105 %{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1106 %pear_install \
1107 %{-z:cd ..} \
1108 cat %{-z:$_N/}.install.log | %__pear_install_log \
1109 \
1110 # undos sources \
1111 find . -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
1112 %{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1113 %{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1114 %{nil}
1115
1116 # Copies exctracted PEAR package structure and PEAR registry to buildroot.
1117 # Author: Elan Ruusamäe <glen@pld-linux.org>
1118 %pear_package_install() \
1119 cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1120 find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1121 # help the developer out a little: \
1122 if [ -f _noautoreq ]; then \
1123         echo "AutoReqdep detected:" \
1124         echo "_noautoreq $(cat _noautoreq)" \
1125 fi \
1126 %{nil}
1127
1128
1129 # Register OpenLDAP schema.
1130 # Author: Elan Ruusamäe <glen@pld-linux.org>
1131 #
1132 # Usage:
1133 #   %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1134 #
1135 #  -d specify dependant schemas, separated by comma
1136 #
1137 %openldap_schema_register(d:) \
1138 for schema in %*; do \
1139         if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1140                 %{__sed} -i -e " \
1141                         /^include.*local.schema/{ \
1142                                 iinclude\\t     $schema\
1143                         } \
1144                 " /etc/openldap/slapd.conf \
1145         fi \
1146 done \
1147 # enable dependant schemas \
1148 if [ "%{-d*}" ]; then \
1149         %{__sed} -i -e ' \
1150         /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1151                 s/^#// \
1152         }' /etc/openldap/slapd.conf \
1153 fi \
1154 %{nil}
1155
1156 # Unregister OpenLDAP schema.
1157 # Author: Elan Ruusamäe <glen@pld-linux.org>
1158 #
1159 # Usage:
1160 #   %%openldap_schema_unregister %{schemadir}/horde.schema
1161 #
1162 %openldap_schema_unregister() \
1163 for schema in %*; do \
1164         if grep -q "$schema" /etc/openldap/slapd.conf; then \
1165                 %{__sed} -i -e " \
1166                 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1167                 # for symmetry it would be nice if we disable enabled schemas in post, \
1168                 # but we really can not do that, it would break something else. \
1169                 " /etc/openldap/slapd.conf \
1170         fi \
1171 done \
1172 %{nil}
1173
1174 %env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1175
1176
1177 # Build modules for kernels 2.6
1178 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1179 #
1180 # Usage:
1181 #       %build_kernel_modules -m <modules> -C <directory>
1182 #
1183 #  remember that proper Makefile is still required
1184 # Options:
1185 #  -m <modules> (required) -- comma-separated list of modules to save,
1186 #               without .ko extension, may be placed in subdirectory
1187 #  -C <directory> -- change to <directory> before doing anything
1188 #  -p <arg>, -P <arg> -- arguments passeed to make scripts
1189 #  -c -- do not execute make clean
1190 #  <additional arguments> -- all additional arguments will be passed to
1191 #               make modules
1192 #
1193 # Additional patching supported via here document. Try:
1194 #       %build_kernel_modules -m module <<'EOF'
1195 #       your patch script here
1196 #       EOF
1197 # Don't use it unless patching depends on config options.
1198
1199 # Developer note: don't touch it unless you know how to handle '\'.
1200 # - \ in script expands to nothing
1201 # - \\\ in script expands to \
1202 # - \\\ inside definition expands to nothing
1203 # - \\\\\\\ inside definition expands to \
1204 # - in last line \ has to touch arguments so arguments passing
1205 #   in new lines (using \) will be supported
1206
1207 %build_kernel_modules(p:P:m:C:c)                                                                        \
1208 %{!?-m:%{error:%{0}: Required module name/list missing} exit 1}         \
1209                                                                                                                                         \
1210 %define Opts                                                                                                            \\\\\\\
1211 %if "%{_target_base_arch}" != "%{_arch}"                                                        \\\
1212         %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"  \\\
1213         CC="%{__cc}" CPP="%{__cpp}" ARCH=%{_target_base_arch}                   \\\
1214         %else                                                                                                                   \\\
1215         ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1216         %endif                                                                                                                  \\\
1217 %else                                                                                                                           \\\
1218         CC="%{__cc}" CPP="%{__cpp}"                                                                             \\\
1219 %endif                                                                                                                          \
1220 %define MakeOpts HOSTCC="%{__cc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1221                 O=$PWD/o %{?with_verbose:V=1} %{Opts}                                           \
1222                                                                                                                                         \
1223 %{?-C:cd %{-C*}}                                                                                                        \
1224 compile() {                                                                                                                     \
1225         L="<"; [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)"    \
1226         set -e -x                                                                                                               \
1227         local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1228                                                                                                                                         \
1229 for cfg in ${cfgs:-dist}; do                                        \
1230         [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1                                 \
1231                                                                                                                                         \
1232         rm -rf o                                                                                                                \
1233         install -d o/include/linux                                                                              \
1234         ln -sf %{_kernelsrcdir}/config-$cfg o/.config                                   \
1235         ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers    \
1236         ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1237 %ifarch ppc ppc64                                                                                                       \
1238         install -d o/include/asm                                                                                \
1239         [ ! -d %{_kernelsrcdir}/include/asm-%{_target_base_arch} ] || ln -snf %{_kernelsrcdir}/include/asm-%{_target_base_arch}/* o/include/asm \
1240         [ ! -d %{_kernelsrcdir}/include/asm-powerpc ] || ln -snf %{_kernelsrcdir}/include/asm-powerpc/* o/include/asm \
1241 %else                                                                                                                           \
1242         ln -sf %{_kernelsrcdir}/include/asm-%{_target_base_arch} o/include/asm \
1243 %endif                                                                                                                          \
1244                                                                                                                                         \
1245         set +x                                                                                                                  \
1246         [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell    \
1247         set -x                                                                                                                  \
1248                                                                                                                                         \
1249         %if %{with dist_kernel}                                                                                 \
1250                 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts                       \\\
1251                         %{-p*} %{-P*}                                                                                   \\\
1252                         %{MakeOpts}                                                                                             \
1253         %else                                                                                                                   \
1254                 install -d o/include/config                                                                     \
1255                 touch o/include/config/MARKER                                                           \
1256                 ln -sf %{_kernelsrcdir}/scripts o/scripts                                       \
1257         %endif                                                                                                                  \
1258                                                                                                                                         \
1259         %{!?-c:%{__make} -C %{_kernelsrcdir} clean                                              \\\
1260                 RCS_FIND_IGNORE="-name '*.ko' -o"                                                       \\\
1261                 M=$PWD %{MakeOpts}}                                                                                     \
1262         %{__make} -C %{_kernelsrcdir} modules                                                   \\\
1263                 ${1+"$@"}                                                                                                       \\\
1264                 M=$PWD %{MakeOpts}                                                                                      \
1265                                                                                                                                         \
1266         for MODULE in {%{-m*},}; do                                                                             \
1267                 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko                           \
1268         done                                                                                                                    \
1269 done                                                                                                                            \
1270 %{?-C:cd -}                                                                                                                     \
1271 }                                                                                                                                       \
1272 compile %{*}\
1273 %{nil}
1274
1275
1276 # Install kernel modules built by %build_kernel_modules
1277 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1278 #
1279 # Usage:
1280 #       %install_kernel_modules -m <modules> -d <directory>
1281 #
1282 # Options:
1283 #  -m <modules> (required) -- comma-separated list of modules to install,
1284 #               without .ko extension, may be placed in subdirectory
1285 #  -d <directory> (required) -- in what subdirectory modules should be
1286 #               installed (eg. misc, kernel/drivers/net)
1287 #  -s <suffix> -- suffix to use when installing modules, useful when module
1288 #               with same name exists in kernel already
1289 #  -n <file> -- name of modprobe config file to use (without .conf extension)
1290 #               for defining aliases, only useful with -s
1291
1292 %install_kernel_modules(m:d:s:n:)                                                                       \
1293 %{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1}          \
1294 %{!?-d:%{error:%{0}: Required module directory missing}exit 1}          \
1295 %{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1296                                                                                                                                         \
1297 %define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}                      \
1298 %define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1299                                                                                                                                         \
1300 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1301                                                                                                                                         \
1302 for MODULE in {%{-m*},}; do                                                                                     \
1303         [ -n "${MODULE}" ] || continue                                                                  \
1304         for cfg in ${cfgs:-dist}; do                                    \
1305                 [ "$cfg" = smp ] && suf=smp || suf=                                                     \
1306                 MNAME=${MODULE##*/}                                                                                     \
1307                 install -D ${MODULE}-$cfg.ko                                                            \\\
1308                         %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                  \
1309                 %{?-s:install -d %{ModprobeD}$suf                                                       \
1310                         echo "alias ${MNAME} ${MNAME}-%{-s*}"                                   \\\
1311                         >> %{ModprobeD}$suf/%{-n*}.conf}                                                \
1312         done                                                                                                                    \
1313 done                                                                                                                            \
1314 %{nil}
1315
1316 # patchset macros
1317 # Author: Elan Ruusamäe <glen@pld-linux.org>
1318 #
1319 # Usage:
1320 #   %patchset_source -f <seq(1) format> <start> [<end>]
1321 #   %patchset_patch <start> [<end>]
1322 #
1323 # If <end> is omited, it is assumed to be <start>.
1324 #
1325 # For example in preamble:
1326 #  %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1327 # and in %prep:
1328 #  %patchset_patch 33 44
1329
1330 # generate SourceX urls from range START STOP
1331 # Format can be SINGLE format char of %e, %f, %g, see seq(1)
1332 # The sources start from 10000
1333 %patchset_source(f:b:) %(
1334         base=%{-b*}%{!-b*:10000};
1335         start=$(expr $base + %1);
1336         end=$(expr $base + %{?2}%{!?2:%{1}});
1337         # we need to call seq twice as it doesn't allow two formats
1338         seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1339         seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1340         paste %{tmpdir}/__ps{1,2};
1341         rm -f %{tmpdir}/__ps{1,2};
1342 ) \
1343 %{nil}
1344
1345 # apply sources from %patchset_source
1346 # -p specify -pX for %patch line
1347 # -b base offset: defaults to 10000
1348 %patchset_patch(f:p:b:) %(
1349         base=%{-b*}%{!-b*:10000};
1350         start=$(expr $base + %1);
1351         end=$(expr $base + %{?2}%{!?2:%{1}});
1352         echo ": patchset_patch %1%{?2: to %2}";
1353         seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1354 ) \
1355 %{nil}
1356
1357 # browser plugins v2
1358 # Author: Elan Ruusamäe <glen@pld-linux.org>
1359 #
1360 # Usage:
1361 #       %browser_plugins_add_browser <name> -p <plugindir>
1362 #
1363 #  <name> (required) -- name of the browser. usually %{name}.
1364 #  -p <plugindir> (required) -- in what directory browser searches for its plugins.
1365 #  -b -- default blacklists
1366 #  -a <arch> override arch
1367 #
1368 # Example:
1369 #   %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1370
1371 %_browserpluginsconfdir         /etc/browser-plugins
1372 %_browserpluginsdir                     %{_libdir}/browser-plugins
1373 %update_browser_plugins         /usr/sbin/update-browser-plugins || :
1374
1375 %browser_plugins_add_browser(p:b:a:) \
1376         browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1377         install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1378         ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1379         blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1380         echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1381         %{-b:cat >> $blacklist_file %{-b*}} \
1382 %{nil}
1383
1384 # vim:ts=4 sw=4 noet syn=spec
This page took 0.280078 seconds and 4 git commands to generate.